<template>
  <div class="searchSelect">
    <v-select
      v-model="selected"
      :disabled="readonly"
      :options="reducedOptions"
      :placeholder="$t('pleaseSelectOption')"
      taggable
      :filter-by="() => true"
      @update:modelValue="input"
      @search="triggerSearch"
    >
      <template #no-options>
        {{ $t("searchSelectNoOptions") }}
      </template>
      <template #selected-option>
        <div
          :id="selected?.replace(/[\/.#:]/g, '') + 'selected'"
          v-b-tooltip.hover.noninteractive.left="selected"
        >
          {{ truncatedSelected }}
        </div>
      </template>

      <template #option="id">
        <div
          :id="'selectOption' + id.label"
          v-b-tooltip.hover.noninteractive.top="{
            title: `${getName(id) + (canShowDescription(id) ? ':' : '')} ${getDescription(id)} (${id.label})`,
          }"
        >
          <h6 style="margin: 0">{{ getName(id) }}</h6>
          <em>{{ id.label }}</em>
        </div>
      </template>
    </v-select>
  </div>
</template>

<script lang="ts">
import { defineComponent, type PropType } from "vue";

import serviceProvider from "@/util/service-providers/service-provider";

import { useMainStore } from "@/store";

import { useDebounceFn } from "@vueuse/core";
const debounceSearch = useDebounceFn(
  async (
    searchString: string | null,
    searchFunction: (searchString: string | null) => Promise<void>,
    loading?: (isLoading: boolean) => void,
  ) => {
    if (loading) {
      loading(true);
    }
    await searchFunction(searchString);
    if (loading) {
      loading(false);
    }
  },
  1000,
);
import truncate from "lodash.truncate";
import type { ApplicationProfile } from "@/types/application-profile";

interface SearchOption {
  description?: { de?: string; en?: string };
  name: string;
  id: string;
}

interface Entry {
  label: string;
}

export default defineComponent({
  name: "SearchSelect",
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    readonly: {
      default: false,
      type: Boolean,
    },
    type: {
      required: true,
      type: String as PropType<"class" | "node">,
    },
    modelValue: {
      default: "",
      type: String,
    },
  },
  setup() {
    const mainStore = useMainStore();

    return { mainStore };
  },
  data() {
    return {
      options: [] as SearchOption[],
      selected: null as string | null,
    };
  },
  computed: {
    optionsById(): { [id: string]: SearchOption } {
      const optionsById: { [id: string]: SearchOption } = {};
      for (const option of this.options) {
        optionsById[option.id] = option;
      }
      return optionsById;
    },
    reducedOptions(): string[] {
      return this.options.map((option) => option.id);
    },
    truncatedSelected(): string {
      if (this.selected) {
        return truncate(this.selected, {
          length: 36,
        });
      }
      return "";
    },
  },
  watch: {
    type() {
      this.options = [];
      if (!this.selected) {
        this.triggerSearch(this.selected);
      }
    },
    value() {
      this.selected = this.modelValue;
    },
  },
  mounted() {
    this.selected = this.modelValue;
    if (!this.selected) {
      this.triggerSearch(this.selected);
    }
  },
  methods: {
    async classSearch(searchString: string | null) {
      const terms = await serviceProvider.apiConnection.searchClasses(
        searchString ?? "",
      );
      this.options = terms.map((term) => {
        return {
          id: term.uri,
          name:
            (term.prefix === undefined ? "" : term.prefix + ":") +
            term.short_form,
          description: term.description,
        };
      });
    },
    async nodeSearch(searchString: string | null) {
      const applicationProfiles =
        await serviceProvider.apiConnection.searchAllApplicationProfiles(
          searchString ?? "",
          {
            language: this.$i18n.locale as "en" | "de",
            state: "public",
          },
        );
      let allApplicationProfiles = [
        ...applicationProfiles,
        ...this.mainStore.searchApplicationProfiles(searchString ?? ""),
      ];
      allApplicationProfiles = allApplicationProfiles.filter(
        (applicationProfile) =>
          applicationProfile.base_url !== this.applicationProfile.base_url,
      );
      this.options = allApplicationProfiles.map((applicationProfile) => {
        return {
          id: applicationProfile.base_url,
          name: applicationProfile.name,
        };
      });
    },
    reduce(option: SearchOption) {
      return option.id;
    },
    async search(
      searchString: string | null,
      searchFunction: (searchString: string | null) => Promise<void>,
      loading?: (isLoading: boolean) => void,
    ) {
      return await debounceSearch(searchString, searchFunction, loading);
    },
    triggerSearch(
      searchString: string | null,
      loading?: (isLoading: boolean) => void,
    ) {
      if (this.type === "class") {
        this.search(searchString, this.classSearch, loading);
      } else if (this.type === "node") {
        this.search(searchString, this.nodeSearch, loading);
      }
    },
    input(searchValue: string | SearchOption | undefined) {
      if (!searchValue) {
        searchValue = "";
      }
      if (typeof searchValue !== "string") {
        searchValue = searchValue.id;
      }
      this.$emit("update:modelValue", searchValue);
      this.triggerSearch("");
    },
    canShowDescription(entry: Entry) {
      const option = this.optionsById[entry.label];
      return (
        option?.description &&
        (option.description[this.$i18n.locale as "de" | "en"] ||
          option.description["en"])
      );
    },
    getDescription(entry: Entry) {
      const option = this.optionsById[entry.label];
      if (option?.description) {
        return (
          option.description[this.$i18n.locale as "de" | "en"] ??
          option.description["en"]
        );
      }
      return "";
    },
    getName(entry: Entry) {
      const option = this.optionsById[entry.label];
      return option ? option.name : "";
    },
  },
});
</script>

<style scoped>
.searchSelect {
  flex-grow: 1;
}
.searchSelect :deep(.vs__dropdown-toggle) {
  height: calc(1.5em + 0.75rem + 2px);
}
</style>
